# disable it for koji
%bcond_with tests
%bcond_with cgns
%bcond_with tetgen

%undefine _package_note_file
%undefine _ld_as_needed

%global _lto_cflags %{nil}
%global blaslib flexiblas
%global blasvar %{nil}
%global majorver %%(echo %{version} | cut -d. -f1)
%global releasever %%(echo %{version} | cut -d. -f1-2)

Summary: Portable Extensible Toolkit for Scientific Computation
Name:    petsc
Version: 3.18.5
Release: 6%{?dist}
License: BSD
URL:     https://petsc.org/
Source0: https://ftp.mcs.anl.gov/pub/petsc/release-snapshots/petsc-with-docs-%{version}.tar.gz
Source1: https://ftp.mcs.anl.gov/pub/petsc/release-snapshots/petsc4py-%{version}.tar.gz

Patch3000:  %{name}-3.11-no-rpath.patch
Patch3001:  %{name}-lib64.patch
Patch3002:  %{name}-3.18.5-fix_make_compatibility.patch
Patch3003:  %{name}-3.18.0-fix_mumps_includes.patch
Patch3004:  %{name}-3.18.0-fix_metis64.patch
Patch3005:  %{name}-3.15.0-fix_sundials_version.patch
Patch3006:  %{name}-3.14.1-fix_pkgconfig_file.patch
Patch3007:  %{name}-3.17.0-avoid_fake_MKL_detection.patch

BuildRequires: SuperLU-devel MUMPS-devel metis-devel %{blaslib}-devel chrpath gcc gcc-c++ cmake3 gcc-gfortran make
BuildRequires: libX11-devel python3-devel python3-setuptools pcre2-devel hdf5-devel xorg-x11-server-Xvfb valgrind-devel
%if %{with cgns}
BuildRequires: cgnslib-devel hdf5-devel
%endif
%if %{with tetgen}
BuildRequires: tetgen-devel
%endif

%description
PETSc, pronounced PET-see (the S is silent), is a suite of data structures and routines for the
scalable (parallel) solution of scientific applications modeled by partial differential equations.

%package devel
Summary:    Portable Extensible Toolkit for Scientific Computation (developer files)
Requires:   %{name} = %{version}-%{release} gcc-gfortran

%description devel
Portable Extensible Toolkit for Scientific Computation (developer files).

%package doc
Summary:    Portable Extensible Toolkit for Scientific Computation (documentation files)
BuildRequires: python3-sphinx
BuildArch:  noarch

%description doc
Portable Extensible Toolkit for Scientific Computation.  PDF and HTML documentation files.

%package -n petsc64
Summary: Portable Extensible Toolkit for Scientific Computation (64bit INTEGER)
BuildRequires: metis64-devel

%description -n petsc64
PETSc, pronounced PET-see (the S is silent), is a suite of data structures and routines for the
scalable (parallel) solution of scientific applications modeled by partial differential equations (64bit INTEGER).

%package -n petsc64-devel
Summary:    Portable Extensible Toolkit for Scientific Computation (64bit INTEGER)
Requires:   %{name}64 = %{version}-%{release}
Requires:   gcc-gfortran

%description -n petsc64-devel
Portable Extensible Toolkit for Scientific Computation (developer files) (64bit INTEGER).

%package openmpi
Summary:    Portable Extensible Toolkit for Scientific Computation (OpenMPI)
BuildRequires: openmpi-devel hdf5-openmpi-devel ptscotch-openmpi-devel scalapack-openmpi-devel blacs-openmpi-devel
BuildRequires: MUMPS-openmpi-devel superlu_dist-openmpi-devel hypre-openmpi-devel
%if %{with cgns}
BuildRequires: cgnslib-devel hdf5-openmpi-devel
%endif
%if %{with fftw}
BuildRequires: fftw-devel fftw-openmpi-devel
%endif

%description openmpi
PETSc, pronounced PET-see (the S is silent), is a suite of data structures and routines for the
scalable (parallel) solution of scientific applications modeled by partial differential equations.

%package openmpi-devel
Summary:    Portable Extensible Toolkit for Scientific Computation (OpenMPI)
Requires:   %{name}-openmpi = %{version}-%{release}  openmpi-devel hdf5-openmpi-devel

%description openmpi-devel
Portable Extensible Toolkit for Scientific Computation (developer files).

%package -n     python%{python3_pkgversion}-%{name}-openmpi
Summary:        Python3 bindings for OpenMPI PETSc
BuildRequires:  python%{python3_pkgversion}-devel python%{python3_pkgversion}-setuptools hdf5-openmpi-devel
BuildRequires:  scalapack-openmpi-devel ptscotch-openmpi-devel python%{python3_pkgversion}-numpy
BuildRequires:  python%{python3_pkgversion}-Cython
Requires: petsc-openmpi hdf5-openmpi scalapack-openmpi ptscotch-openmpi openmpi MUMPS-openmpi
Provides:       python%{python3_pkgversion}-petsc4py-openmpi
Provides:       python-petsc4py-openmpi
Provides:       petsc4py-openmpi

%description -n python%{python3_pkgversion}-%{name}-openmpi
This package provides Python3 bindings for OpenMPI PETSc, the Portable, Extensible Toolkit for Scientific Computation.

%package -n     python%{python3_pkgversion}-%{name}-mpich
Summary:        Python3 bindings for MPICH PETSc
BuildRequires:  python%{python3_pkgversion}-devel python%{python3_pkgversion}-setuptools hdf5-mpich-devel
BuildRequires:  scalapack-mpich-devel ptscotch-mpich-devel python%{python3_pkgversion}-numpy
BuildRequires:  python%{python3_pkgversion}-Cython
Requires: petsc-mpich hdf5-mpich scalapack-openmpi ptscotch-mpich mpich MUMPS-mpich
Provides:       python%{python3_pkgversion}-petsc4py-mpich
Provides:       python-petsc4py-mpich
Provides:       petsc4py-mpich

%description -n python%{python3_pkgversion}-%{name}-mpich
This package provides Python3 bindings for MPICH PETSc, the Portable, Extensible Toolkit for Scientific Computation.

%package mpich
Summary:    Portable Extensible Toolkit for Scientific Computation (MPICH)
BuildRequires: mpich-devel hdf5-mpich-devel ptscotch-mpich-devel scalapack-mpich-devel blacs-mpich-devel
BuildRequires: MUMPS-mpich-devel superlu_dist-mpich-devel hypre-mpich-devel
%if %{with cgns}
BuildRequires: cgnslib-devel hdf5-mpich-devel
%endif
%if %{with fftw}
BuildRequires: fftw-devel fftw-mpich-devel
%endif
Requires:   mpich

%description mpich
PETSc, pronounced PET-see (the S is silent), is a suite of data structures and routines for the
scalable (parallel) solution of scientific applications modeled by partial differential equations.

%package mpich-devel
Summary:    Portable Extensible Toolkit for Scientific Computation (MPICH)
Requires:   %{name}-mpich = %{version}-%{release}
Requires:   mpich-devel hdf5-mpich-devel

%description mpich-devel
Portable Extensible Toolkit for Scientific Computation (developer files).

%prep
%setup -qc

%setup -q -T -D -a 1
cp -a petsc4py-%{version}/* %{name}-%{version}/
rm -rf %{name}-%{version}/*.egg-info
rm -rf petsc4py-%{version}

pushd %{name}-%{version}
%patch3002 -p1 -b .backup
%patch3007 -p1 -b .backup
popd

pushd %{name}-%{version}
rm $(grep -rl '/\* Generated by Cython')
popd

cp -a %{name}-%{version} build64
pushd build64
%patch3001 -p0
%patch3004 -p1 -b .metis64
popd

pushd %{name}-%{version}
%patch3000 -p0 -b .backup
%patch3005 -p1 -b .backup
%patch3006 -p1 -b .backup
popd

cp -a %{name}-%{version} buildopenmpi_dir
cp -a %{name}-%{version} buildmpich_dir

pushd %{name}-%{version}
%patch3003 -p1 -b .backup
popd

%build
pushd %{name}-%{version}
%configure --with-cc=gcc --with-cxx=g++ --with-fc=gfortran \
 CFLAGS="-O0 -g -Wl,-z,now -fPIC" CXXFLAGS="-O0 -g -Wl,-z,now -fPIC" FFLAGS="-O0 -g -Wl,-z,now -fPIC -I%{_libdir}/gfortran/modules" COPTFLAGS="-O0 -g -Wl,-z,now" \
  CXXOPTFLAGS="-O0 -g -Wl,-z,now" FOPTFLAGS="-O0 -g -Wl,-z,now -I%{_libdir}/gfortran/modules" LDFLAGS="$LDFLAGS -fPIC" \
  FCFLAGS="-O0 -g -Wl,-z,now -fPIC -I%{_libdir}/gfortran/modules" \
 --CC_LINKER_FLAGS="$LDFLAGS" \
 --FC_LINKER_FLAGS="$LDFLAGS -lgfortran" \
 --with-default-arch=0 --with-make=1 \
 --with-cmake-exec=%{_bindir}/cmake3 --with-ctest-exec=%{_bindir}/ctest3 \
 --with-single-library=1 \
 --with-precision=double \
 --with-petsc-arch=%{_arch} \
 --with-clanguage=C \
 --with-shared-libraries=1 \
 --with-fortran-interfaces=1 \
 --with-windows-graphics=0 \
 --CC=gcc \
 --FC=gfortran \
 --CXX=g++ \
 --with-shared-ld=ld \
 --with-pic=1 \
 --with-clib-autodetect=0 \
 --with-fortranlib-autodetect=0 \
 --with-threadsafety=0 --with-log=1 \
 --with-mkl_sparse=0 \
 --with-mkl_sparse_optimize=0 \
 --with-mkl_cpardiso=0 \
 --with-mkl_pardiso=0 \
 --with-python=0 \
 --with-cxxlib-autodetect=1 \
 --with-debugging=1 \
 --with-mumps-serial=1 \
 --with-mpi=0 \
 --with-hdf5=1 \
 --with-hdf5-include= \
 --with-hdf5-lib="-lhdf5 -lhdf5_hl" \
%if %{with cgns}
 --with-cgns=0 \
%endif
 --with-x=1 \
 --with-openmp=0 \
 --with-hwloc=0 \
 --with-ssl=0 \
 --with-pthread=1 \
 --with-valgrind=1 \
 --with-64-bit-indices=0 \
 --with-blaslapack=1 --with-blaslapack-lib=-l%{blaslib}%{blasvar} --with-blaslapack-include=%{_includedir}/%{blaslib} \
 --with-metis=1 \
%if %{with tetgen}
 --with-tetgen=1 \
 --with-tetgen-lib=-ltetgen \
%endif
 --with-superlu=1 \
 --with-superlu-include=%{_includedir}/SuperLU \
 --with-superlu-lib=-lsuperlu

RPM_BUILD_NCPUS="`%{_bindir}/getconf _NPROCESSORS_ONLN`"
make \
 V=1 MAKE_NP=$RPM_BUILD_NCPUS PETSC_DIR=%{_builddir}/%{name}-%{version}/%{name}-%{version} PETSC_ARCH=%{_arch} all
popd

pushd build64
%configure --with-cc=gcc --with-cxx=g++ --with-fc=gfortran \
 CFLAGS="-O0 -g -Wl,-z,now -fPIC" CXXFLAGS="-O0 -g -Wl,-z,now -fPIC" FFLAGS="-O0 -g -Wl,-z,now -fPIC -I%{_libdir}/gfortran/modules" COPTFLAGS="-O0 -g -Wl,-z,now" \
  CXXOPTFLAGS="-O0 -g -Wl,-z,now" FOPTFLAGS="-O0 -g -Wl,-z,now -I%{_libdir}/gfortran/modules" LDFLAGS="$LDFLAGS -fPIC" \
  FCFLAGS="-O0 -g -Wl,-z,now -fPIC -I%{_libdir}/gfortran/modules" \
 --CC_LINKER_FLAGS="$LDFLAGS" \
 --FC_LINKER_FLAGS="$LDFLAGS -lgfortran" \
 --with-default-arch=0 --with-make=1 \
 --with-cmake-exec=%{_bindir}/cmake3 --with-ctest-exec=%{_bindir}/ctest3 \
 --with-single-library=1 \
 --with-precision=double \
 --with-petsc-arch=%{_arch} \
 --with-clanguage=C \
 --with-shared-libraries=1 \
 --with-fortran-interfaces=1 \
 --with-windows-graphics=0 \
 --CC=gcc \
 --FC=gfortran \
 --CXX=g++ \
 --with-shared-ld=ld \
 --with-pic=1 \
 --with-clib-autodetect=0 \
 --with-fortranlib-autodetect=0 \
 --with-threadsafety=0 --with-log=1 \
 --with-mkl_sparse=0 \
 --with-mkl_sparse_optimize=0 \
 --with-mkl_cpardiso=0 \
 --with-mkl_pardiso=0 \
 --with-python=0 \
 --with-cxxlib-autodetect=1 \
 --with-debugging=1 \
 --with-mumps-serial=1 \
 --with-mpi=0 \
 --with-hdf5=1 \
 --with-hdf5-include= \
 --with-hdf5-lib="-lhdf5 -lhdf5_hl" \
%if %{with cgns}
 --with-cgns=0 \
%endif
 --with-x=1 \
 --with-openmp=0 \
 --with-hwloc=0 \
 --with-ssl=0 \
 --with-pthread=1 \
 --with-valgrind=1 \
 --with-64-bit-indices=1 \
 --with-metis=1 \
 --with-blaslapack=1 --with-blaslapack-lib=-l%{blaslib}%{blasvar}64 --with-blaslapack-include=%{_includedir}/%{blaslib}

RPM_BUILD_NCPUS="`%{_bindir}/getconf _NPROCESSORS_ONLN`"
make \
 V=1 MAKE_NP=$RPM_BUILD_NCPUS PETSC_DIR=%{_builddir}/%{name}-%{version}/build64 PETSC_ARCH=%{_arch} all
popd

pushd buildopenmpi_dir

%{_openmpi_load}
export CC=mpicc
export CXX=mpic++
export FC=mpifort
%configure --with-cc=mpicc --with-cxx=mpic++ --with-fc=mpifort \
 --FC_LINKER_FLAGS="$LDFLAGS -lgfortran -lmpi_mpifh" \
 --LIBS=" -lmpi -lmpi_mpifh" \
 CFLAGS="-O0 -g -Wl,-z,now -fPIC" CXXFLAGS="-O0 -g -Wl,-z,now -fPIC" FFLAGS="-O0 -g -Wl,-z,now -fPIC -I${MPI_FORTRAN_MOD_DIR}" COPTFLAGS="-O0 -g -Wl,-z,now" \
  CXXOPTFLAGS="-O0 -g -Wl,-z,now" FOPTFLAGS="-O0 -g -Wl,-z,now -I${MPI_FORTRAN_MOD_DIR}" LDFLAGS="$LDFLAGS -fPIC" \
  FCFLAGS="-O0 -g -Wl,-z,now -fPIC -I${MPI_FORTRAN_MOD_DIR}" \
 --CC_LINKER_FLAGS="$LDFLAGS" \
 --with-default-arch=0 --with-make=1 \
 --with-cmake-exec=%{_bindir}/cmake3 --with-ctest-exec=%{_bindir}/ctest3 \
 --with-single-library=1 \
 --with-precision=double \
 --with-petsc-arch=%{_arch} \
 --with-clanguage=C \
 --with-shared-libraries=1 \
 --with-fortran-interfaces=1 \
 --with-windows-graphics=0 \
 --with-cc=${MPI_BIN}/mpicc \
 --with-cxx=${MPI_BIN}/mpicxx \
 --with-fc=${MPI_BIN}/mpif90 \
 --with-shared-ld=ld \
 --with-pic=1 \
 --with-clib-autodetect=0 \
 --with-fortranlib-autodetect=0 \
 --with-mkl_sparse=0 \
 --with-mkl_sparse_optimize=0 \
 --with-mkl_cpardiso=0 \
 --with-mkl_pardiso=0 \
 --with-python=1 \
 --with-python-exec=%{__python3} \
 --with-petsc4py=1 \
 --with-petsc4py-test-np="`/usr/bin/getconf _NPROCESSORS_ONLN`" \
 --with-cxxlib-autodetect=1 \
 --with-threadsafety=0 --with-log=1 \
 --with-debugging=1 \
 --with-mpiexec="${MPI_BIN}/mpiexec -n `/usr/bin/getconf _NPROCESSORS_ONLN` --mca btl_base_warn_component_unused 0 --mca orte_base_help_aggregate 0" \
 --with-scalapack=1 \
 --with-scalapack-lib="-L$MPI_LIB -lscalapack" \
 --with-scalapck-include="" \
 --with-mpi=1 \
%if %{with cgns}
 --with-cgns=1 \
 --with-cgns-include=%{_includedir} \
 --with-cgns-lib=-lcgns \
%endif
 --with-hdf5=1 \
 --with-hdf5-include= \
 --with-hdf5-lib="-L$MPI_LIB -lhdf5 -lhdf5_hl" \
 --with-ptscotch=1 \
 --with-ptscotch-include=$MPI_INCLUDE/scotch \
 --with-ptscotch-lib="-L$MPI_LIB -lptscotch -lscotch -lptscotcherr -lscotcherr" \
 --with-mumps=1 \
 --with-superlu_dist=1 \
 --with-superlu_dist-include=$MPI_INCLUDE/superlu_dist \
 --with-superlu_dist-lib=-lsuperlu_dist \
 --with-x=1 \
 --with-openmp=0 \
 --with-hwloc=0 \
 --with-ssl=0 \
 --with-hypre=1 \
 --with-hypre-include=$MPI_INCLUDE/hypre \
 --with-hypre-lib="-L$MPI_LIB -lHYPRE" \
%if %{with fftw}
 --with-fftw=1 \
 --with-fftw-include= \
 --with-fftw-lib="-L$MPI_LIB -lfftw3_mpi -lfftw3" \
%endif
 --with-pthread=1 \
 --with-valgrind=1 \
 --with-metis=1 \
 --with-64-bit-indices=0 \
 --with-blaslapack=1 --with-blaslapack-lib=-l%{blaslib}%{blasvar} --with-blaslapack-include=%{_includedir}/%{blaslib} \

RPM_BUILD_NCPUS="`%{_bindir}/getconf _NPROCESSORS_ONLN`"
make \
 V=1 MAKE_NP=$RPM_BUILD_NCPUS PETSC_DIR=%{_builddir}/%{name}-%{version}/buildopenmpi_dir PETSC_ARCH=%{_arch} all
 
export PETSC_ARCH=%{_arch}
export PETSC_DIR=./
%py3_build
unset PETSC_ARCH
unset PETSC_DIR

%{_openmpi_unload}
popd

pushd buildmpich_dir

%{_mpich_load}
export CC=mpicc
export CXX=mpic++
export FC=mpifort
%configure --with-cc=mpicc --with-cxx=mpic++ --with-fc=mpifort \
 --FC_LINKER_FLAGS="$LDFLAGS -lgfortran -lfmpich -lmpichf90" \
 --LIBS=" -lmpich -lfmpich -lmpichf90" \
 CFLAGS="-O0 -g -Wl,-z,now -fPIC" CXXFLAGS="-O0 -g -Wl,-z,now -fPIC" FFLAGS="-O0 -g -Wl,-z,now -fPIC -I${MPI_FORTRAN_MOD_DIR}" COPTFLAGS="-O0 -g -Wl,-z,now" \
  CXXOPTFLAGS="-O0 -g -Wl,-z,now" FOPTFLAGS="-O0 -g -Wl,-z,now -I${MPI_FORTRAN_MOD_DIR}" LDFLAGS="$LDFLAGS -fPIC" \
  FCFLAGS="-O0 -g -Wl,-z,now -fPIC -I${MPI_FORTRAN_MOD_DIR}" \
 --CC_LINKER_FLAGS="$LDFLAGS" \
 --with-default-arch=0 --with-make=1 \
 --with-cmake-exec=%{_bindir}/cmake3 --with-ctest-exec=%{_bindir}/ctest3 \
 --with-single-library=1 \
 --with-precision=double \
 --with-petsc-arch=%{_arch} \
 --with-clanguage=C \
 --with-shared-libraries=1 \
 --with-fortran-interfaces=1 \
 --with-windows-graphics=0 \
 --with-cc=${MPI_BIN}/mpicc \
 --with-cxx=${MPI_BIN}/mpicxx \
 --with-fc=${MPI_BIN}/mpif90 \
 --with-shared-ld=ld \
 --with-pic=1 \
 --with-clib-autodetect=0 \
 --with-fortranlib-autodetect=0 \
 --with-mkl_sparse=0 \
 --with-mkl_sparse_optimize=0 \
 --with-mkl_cpardiso=0 \
 --with-mkl_pardiso=0 \
 --with-python=1 \
 --with-python-exec=%{__python3} \
 --with-petsc4py=1 \
 --with-petsc4py-test-np="`/usr/bin/getconf _NPROCESSORS_ONLN`" \
 --with-cxxlib-autodetect=1 \
 --with-threadsafety=0 --with-log=1 \
 --with-debugging=1 \
 --with-mpiexec="${MPI_BIN}/mpiexec -n `/usr/bin/getconf _NPROCESSORS_ONLN` --mca btl_base_warn_component_unused 0 --mca orte_base_help_aggregate 0" \
 --with-scalapack=1 \
 --with-scalapack-lib="-L$MPI_LIB -lscalapack" \
 --with-scalapck-include="" \
 --with-mpi=1 \
%if %{with cgns}
 --with-cgns=1 \
 --with-cgns-include=%{_includedir} \
 --with-cgns-lib=-lcgns \
%endif
 --with-hdf5=1 \
 --with-hdf5-include= \
 --with-hdf5-lib="-L$MPI_LIB -lhdf5 -lhdf5_hl" \
 --with-ptscotch=1 \
 --with-ptscotch-include=$MPI_INCLUDE/scotch \
 --with-ptscotch-lib="-L$MPI_LIB -lptscotch -lscotch -lptscotcherr -lscotcherr" \
 --with-mumps=1 \
 --with-superlu_dist=1 \
 --with-superlu_dist-include=$MPI_INCLUDE/superlu_dist \
 --with-superlu_dist-lib=-lsuperlu_dist \
 --with-x=1 \
 --with-openmp=0 \
 --with-hwloc=0 \
 --with-ssl=0 \
 --with-hypre=1 \
 --with-hypre-include=$MPI_INCLUDE/hypre \
 --with-hypre-lib="-L$MPI_LIB -lHYPRE" \
%if %{with fftw}
 --with-fftw=1 \
 --with-fftw-include= \
 --with-fftw-lib="-L$MPI_LIB -lfftw3_mpi -lfftw3" \
%endif
 --with-pthread=1 \
 --with-valgrind=1 \
 --with-metis=1 \
 --with-64-bit-indices=0 \
 --with-blaslapack=1 --with-blaslapack-lib=-l%{blaslib}%{blasvar} --with-blaslapack-include=%{_includedir}/%{blaslib} \

RPM_BUILD_NCPUS="`%{_bindir}/getconf _NPROCESSORS_ONLN`"
make \
 V=1 MAKE_NP=$RPM_BUILD_NCPUS PETSC_DIR=%{_builddir}/%{name}-%{version}/buildmpich_dir PETSC_ARCH=%{_arch} all

export PETSC_ARCH=%{_arch}
export PETSC_DIR=./
%py3_build
unset PETSC_ARCH
unset PETSC_DIR

%{_mpich_unload}
popd

%install
pushd %{name}-%{version}
mkdir -p %{buildroot}%{_libdir} %{buildroot}%{_includedir}/%{name}
mkdir -p %{buildroot}%{_fmoddir}/%{name}
mkdir -p %{buildroot}%{_libdir}/%{name}/conf

install -pm 755 %{_arch}/lib/libpetsc.* %{buildroot}%{_libdir}
ln -sf libpetsc.so.%{version} %{buildroot}%{_libdir}/libpetsc.so
ln -sf libpetsc.so.%{version} %{buildroot}%{_libdir}/libpetsc.so.%{releasever}
ln -sf libpetsc.so.%{version} %{buildroot}%{_libdir}/libpetsc.so.%{majorver}

install -pm 644 %{_arch}/include/*.h %{buildroot}%{_includedir}/%{name}/
install -pm 644 %{_arch}/include/*.mod %{buildroot}%{_fmoddir}/%{name}/
cp -a include/* %{buildroot}%{_includedir}/%{name}/

cp -a %{_arch}/lib/pkgconfig %{buildroot}%{_libdir}/
sed -e 's|${prefix}/lib|${prefix}/%{_lib}|g' -i %{buildroot}%{_libdir}/pkgconfig/PETSc.pc
ln -fs %{_libdir}/pkgconfig/PETSc.pc %{buildroot}%{_libdir}/pkgconfig/petsc.pc

install -pm 644 %{_arch}/lib/petsc/conf/petscrules %{buildroot}%{_libdir}/%{name}/conf/
install -pm 644 %{_arch}/lib/petsc/conf/petscvariables %{buildroot}%{_libdir}/%{name}/conf/
install -pm 644 lib/petsc/conf/rules %{buildroot}%{_libdir}/%{name}/conf/
install -pm 644 lib/petsc/conf/variables %{buildroot}%{_libdir}/%{name}/conf/
sed -e 's|%{_builddir}/%{name}-%{version}/%{name}-%{version}|%{_prefix}|g' -i %{buildroot}%{_libdir}/%{name}/conf/petscvariables
sed -e 's|%{_builddir}/%{name}-%{version}/%{name}-%{version}/%{_arch}/|%{_prefix}|g' -i %{buildroot}%{_libdir}/%{name}/conf/petscvariables
sed -e 's|-L%{_prefix}/%{_arch}/lib|-L%{_libdir}|g' -i %{buildroot}%{_libdir}/%{name}/conf/petscvariables
sed -e 's|-I%{_prefix}/%{_arch}/include|-I%{_includedir}/%{name} -I%{_fmoddir}/%{name}|g' -i %{buildroot}%{_libdir}/%{name}/conf/petscvariables
sed -e 's|${PETSC_DIR}/${PETSC_ARCH}/lib|%{_libdir}|g' -i %{buildroot}%{_libdir}/%{name}/conf/variables
sed -e 's|${PETSC_DIR}/${PETSC_ARCH}/lib|%{_libdir}|g' -i %{buildroot}%{_libdir}/%{name}/conf/rules
sed -e 's|${PETSC_DIR}|%{_prefix}|g' -i %{buildroot}%{_libdir}/%{name}/conf/petscrules
sed -e 's|${PETSC_DIR}|%{_prefix}|g' -i %{buildroot}%{_libdir}/%{name}/conf/petscvariables
popd

pushd build64
mkdir -p %{buildroot}%{_libdir} %{buildroot}%{_includedir}/%{name}64
mkdir -p %{buildroot}%{_fmoddir}/%{name}64
mkdir -p %{buildroot}%{_libdir}/%{name}64/conf
mkdir -p %{buildroot}%{_libdir}/pkgconfig

install -pm 755 %{_arch}/lib/libpetsc64.* %{buildroot}%{_libdir}
ln -sf libpetsc64.so.%{version} %{buildroot}%{_libdir}/libpetsc64.so
ln -sf libpetsc64.so.%{version} %{buildroot}%{_libdir}/libpetsc64.so.%{releasever}
ln -sf libpetsc64.so.%{version} %{buildroot}%{_libdir}/libpetsc64.so.%{majorver}

install -pm 644 %{_arch}/include/*.h %{buildroot}%{_includedir}/%{name}64/
install -pm 644 %{_arch}/include/*.mod %{buildroot}%{_fmoddir}/%{name}64/
cp -a include/* %{buildroot}%{_includedir}/%{name}64/

cp -p %{_arch}/lib/pkgconfig/PETSc.pc %{buildroot}%{_libdir}/pkgconfig/PETSc64.pc
cp -p %{_arch}/lib/pkgconfig/PETSc.pc %{buildroot}%{_libdir}/pkgconfig/petsc64.pc
sed -e 's|${prefix}/lib|${prefix}/%{_lib}|g' -i %{buildroot}%{_libdir}/pkgconfig/PETSc64.pc
sed -e 's|${prefix}/lib|${prefix}/%{_lib}|g' -i %{buildroot}%{_libdir}/pkgconfig/petsc64.pc

install -pm 644 %{_arch}/lib/petsc/conf/petscrules %{buildroot}%{_libdir}/%{name}64/conf/
install -pm 644 %{_arch}/lib/petsc/conf/petscvariables %{buildroot}%{_libdir}/%{name}64/conf/
install -pm 644 lib/petsc/conf/rules %{buildroot}%{_libdir}/%{name}64/conf/
install -pm 644 lib/petsc/conf/variables %{buildroot}%{_libdir}/%{name}64/conf/
sed -e 's|%{_builddir}/%{name}-%{version}/build64|%{_prefix}|g' -i %{buildroot}%{_libdir}/%{name}64/conf/petscvariables
sed -e 's|%{_builddir}/%{name}-%{version}/build64/%{_arch}/|%{_prefix}|g' -i %{buildroot}%{_libdir}/%{name}64/conf/petscvariables
sed -e 's|-L%{_prefix}/%{_arch}/lib|-L%{_libdir}|g' -i %{buildroot}%{_libdir}/%{name}64/conf/petscvariables
sed -e 's|-I%{_prefix}/%{_arch}/include/|-I%{_includedir}/%{name}64 -I%{_fmoddir}/%{name}64|g' -i %{buildroot}%{_libdir}/%{name}64/conf/petscvariables
sed -e 's|${PETSC_DIR}/${PETSC_ARCH}/lib|%{_libdir}|g' -i %{buildroot}%{_libdir}/%{name}64/conf/variables
sed -e 's|${PETSC_DIR}/${PETSC_ARCH}/lib|%{_libdir}|g' -i %{buildroot}%{_libdir}/%{name}64/conf/rules
sed -e 's|${PETSC_DIR}|%{_prefix}|g' -i %{buildroot}%{_libdir}/%{name}/conf/petscrules
sed -e 's|${PETSC_DIR}|%{_prefix}|g' -i %{buildroot}%{_libdir}/%{name}/conf/petscvariables
popd

pushd buildopenmpi_dir
%{_openmpi_load}
mkdir -p %{buildroot}$MPI_LIB %{buildroot}$MPI_INCLUDE/%{name}
mkdir -p %{buildroot}$MPI_FORTRAN_MOD_DIR/%{name}
mkdir -p %{buildroot}$MPI_LIB/%{name}/conf

install -pm 755 %{_arch}/lib/libpetsc.* %{buildroot}$MPI_LIB
ln -sf libpetsc.so.%{version} %{buildroot}$MPI_LIB/libpetsc.so
ln -sf libpetsc.so.%{version} %{buildroot}$MPI_LIB/libpetsc.so.%{releasever}
ln -sf libpetsc.so.%{version} %{buildroot}$MPI_LIB/libpetsc.so.%{majorver}

install -pm 644 %{_arch}/include/*.h %{buildroot}$MPI_INCLUDE/%{name}/
install -pm 644 %{_arch}/include/*.mod %{buildroot}$MPI_FORTRAN_MOD_DIR/%{name}/
cp -a include/* %{buildroot}$MPI_INCLUDE/%{name}/

cp -a %{_arch}/lib/pkgconfig %{buildroot}$MPI_LIB/
sed -e 's|-I${includedir}/petsc|-I%{_includedir}/openmpi-%{_arch}/petsc|g' -i %{buildroot}$MPI_LIB/pkgconfig/PETSc.pc
sed -e 's|-L${libdir}|-L%{_libdir}/openmpi/lib|g' -i %{buildroot}$MPI_LIB/pkgconfig/PETSc.pc
sed -e 's|ldflag_rpath=-L|ldflag_rpath=-L%{_libdir}/openmpi/lib|g' -i %{buildroot}$MPI_LIB/pkgconfig/PETSc.pc
sed -e 's|-lpetsc|-lpetsc -lhdf5|' -i %{buildroot}$MPI_LIB/pkgconfig/PETSc.pc
sed -e 's|${prefix}/lib|${prefix}/%{_lib}/openmpi/lib|g' -i %{buildroot}$MPI_LIB/pkgconfig/PETSc.pc
ln -fs $MPI_LIB/pkgconfig/PETSc.pc %{buildroot}$MPI_LIB/pkgconfig/petsc.pc

install -pm 644 %{_arch}/lib/petsc/conf/petscrules %{buildroot}$MPI_LIB/%{name}/conf/
install -pm 644 %{_arch}/lib/petsc/conf/petscvariables %{buildroot}$MPI_LIB/%{name}/conf/
install -pm 644 lib/petsc/conf/rules %{buildroot}$MPI_LIB/%{name}/conf/
install -pm 644 lib/petsc/conf/variables %{buildroot}$MPI_LIB/%{name}/conf/
sed -e 's|%{_builddir}/%{name}-%{version}/buildopenmpi_dir|%{_prefix}|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscvariables
sed -e 's|%{_builddir}/%{name}-%{version}/buildopenmpi_dir/%{_arch}/|%{_prefix}|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscvariables
sed -e 's|-L%{_prefix}/%{_arch}/lib|-L%{_libdir}/openmpi/lib|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscvariables
sed -e 's|-I%{_prefix}/%{_arch}/include|-I%{_includedir}/openmpi-%{_arch}/%{name} -I%{_fmoddir}/openmpi/%{name}|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscvariables
sed -e 's|${PETSC_DIR}/${PETSC_ARCH}/lib|%{_libdir}/openmpi/lib|g' -i %{buildroot}$MPI_LIB/%{name}/conf/variables
sed -e 's|${PETSC_DIR}/${PETSC_ARCH}/lib|%{_libdir}/openmpi/lib|g' -i %{buildroot}$MPI_LIB/%{name}/conf/rules
sed -e 's|${PETSC_DIR}|%{_prefix}|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscrules
sed -e 's|${PETSC_DIR}|%{_prefix}|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscvariables

export PETSC_ARCH=%{_arch}
export PETSC_DIR=./
%py3_install

MPI_PYTHON3_SITEARCH=%{python3_sitearch}/openmpi

mkdir -p %{buildroot}$MPI_PYTHON3_SITEARCH
cp -a %{buildroot}%{python3_sitearch}/petsc4py %{buildroot}$MPI_PYTHON3_SITEARCH/
rm -rf %{buildroot}%{python3_sitearch}/petsc4py
cp -a %{buildroot}%{python3_sitearch}/petsc4py-%{version}-py%{python3_version}.egg-info %{buildroot}$MPI_PYTHON3_SITEARCH/
rm -rf %{buildroot}%{python3_sitearch}/petsc4py-%{version}-py%{python3_version}.egg-info

chrpath -r %{_libdir}/openmpi/lib %{buildroot}$MPI_PYTHON3_SITEARCH/petsc4py/lib/%{_arch}/*.so

%{_openmpi_unload}
popd

pushd buildmpich_dir
%{_mpich_load}
mkdir -p %{buildroot}$MPI_LIB %{buildroot}$MPI_INCLUDE/%{name}
mkdir -p %{buildroot}$MPI_FORTRAN_MOD_DIR/%{name}
mkdir -p %{buildroot}$MPI_LIB/%{name}/conf

install -pm 755 %{_arch}/lib/libpetsc.* %{buildroot}$MPI_LIB
ln -sf libpetsc.so.%{version} %{buildroot}$MPI_LIB/libpetsc.so
ln -sf libpetsc.so.%{version} %{buildroot}$MPI_LIB/libpetsc.so.%{releasever}
ln -sf libpetsc.so.%{version} %{buildroot}$MPI_LIB/libpetsc.so.%{majorver}

install -pm 644 %{_arch}/include/*.h %{buildroot}$MPI_INCLUDE/%{name}/
install -pm 644 %{_arch}/include/*.mod %{buildroot}$MPI_FORTRAN_MOD_DIR/%{name}/
cp -a include/* %{buildroot}$MPI_INCLUDE/%{name}/

cp -a %{_arch}/lib/pkgconfig %{buildroot}$MPI_LIB/
sed -e 's|-I${includedir}/petsc|-I%{_includedir}/mpich-%{_arch}/petsc|g' -i %{buildroot}$MPI_LIB/pkgconfig/PETSc.pc
sed -e 's|-L${libdir}|-L%{_libdir}/mpich/lib|g' -i %{buildroot}$MPI_LIB/pkgconfig/PETSc.pc
sed -e 's|ldflag_rpath=-L|ldflag_rpath=-L%{_libdir}/mpich/lib|g' -i %{buildroot}$MPI_LIB/pkgconfig/PETSc.pc
sed -e 's|-lpetsc|-lpetsc -lhdf5|' -i %{buildroot}$MPI_LIB/pkgconfig/PETSc.pc
sed -e 's|${prefix}/lib|${prefix}/%{_lib}/mpich/lib|g' -i %{buildroot}$MPI_LIB/pkgconfig/PETSc.pc
ln -fs $MPI_LIB/pkgconfig/PETSc.pc %{buildroot}$MPI_LIB/pkgconfig/petsc.pc

install -pm 644 %{_arch}/lib/petsc/conf/petscrules %{buildroot}$MPI_LIB/%{name}/conf/
install -pm 644 %{_arch}/lib/petsc/conf/petscvariables %{buildroot}$MPI_LIB/%{name}/conf/
install -pm 644 lib/petsc/conf/rules %{buildroot}$MPI_LIB/%{name}/conf/
install -pm 644 lib/petsc/conf/variables %{buildroot}$MPI_LIB/%{name}/conf/
sed -e 's|%{_builddir}/%{name}-%{version}/buildmpich_dir|%{_prefix}|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscvariables
sed -e 's|%{_builddir}/%{name}-%{version}/buildmpich_dir/%{_arch}/|%{_prefix}|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscvariables
sed -e 's|-L%{_prefix}/%{_arch}/lib|-L%{_libdir}/mpich/lib|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscvariables
sed -e 's|-I%{_prefix}/%{_arch}/include|-I%{_includedir}/mpich-%{_arch}/%{name} -I%{_fmoddir}/mpich/%{name}|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscvariables
sed -e 's|${PETSC_DIR}/${PETSC_ARCH}/lib|%{_libdir}/mpich/lib|g' -i %{buildroot}$MPI_LIB/%{name}/conf/variables
sed -e 's|${PETSC_DIR}/${PETSC_ARCH}/lib|%{_libdir}/mpich/lib|g' -i %{buildroot}$MPI_LIB/%{name}/conf/rules
sed -e 's|${PETSC_DIR}|%{_prefix}|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscrules
sed -e 's|${PETSC_DIR}|%{_prefix}|g' -i %{buildroot}$MPI_LIB/%{name}/conf/petscvariables

export PETSC_ARCH=%{_arch}
export PETSC_DIR=./
%py3_install

MPI_PYTHON3_SITEARCH=%{python3_sitearch}/mpich

mkdir -p %{buildroot}$MPI_PYTHON3_SITEARCH
cp -a %{buildroot}%{python3_sitearch}/petsc4py %{buildroot}$MPI_PYTHON3_SITEARCH/
rm -rf %{buildroot}%{python3_sitearch}/petsc4py
cp -a %{buildroot}%{python3_sitearch}/petsc4py-%{version}-py%{python3_version}.egg-info %{buildroot}$MPI_PYTHON3_SITEARCH/
rm -rf %{buildroot}%{python3_sitearch}/petsc4py-%{version}-py%{python3_version}.egg-info

chrpath -r %{_libdir}/mpich/lib %{buildroot}$MPI_PYTHON3_SITEARCH/petsc4py/lib/%{_arch}/*.so
%{_mpich_unload}
popd

pushd %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_pkgdocdir}/headers
for i in `find . -name "*.h.html" -type f -print`; do
    mv $i %{buildroot}%{_pkgdocdir}/headers
done
for i in `find . -name "*.html" -type f -print`; do
    mv $i %{buildroot}%{_pkgdocdir}/headers
done
find . -name "Makefile" -type f -print | xargs /bin/rm -f
popd
cp -a %{name}-%{version}/docs/* %{buildroot}%{_pkgdocdir}

%check
%if %{with tests}
%{_openmpi_load}
export LD_LIBRARY_PATH=%{buildroot}$MPI_LIB
export PETSC_DIR=%{_builddir}/%{name}-%{version}/buildopenmpi_dir
export PETSC_ARCH=%{_arch}
export MPI_INTERFACE_HOSTNAME=localhost
export OMPI_MCA_btl_base_warn_component_unused=0
export wPETSC_DIR=./
export DATAFILESPATH=%{_builddir}/%{name}-%{version}/buildopenmpi_dir/share/petsc/datafiles
RPM_BUILD_NCPUS="`%{_bindir}/getconf _NPROCESSORS_ONLN`"
export PETSCVALGRIND_OPTIONS=" --tool=memcheck --leak-check=yes --track-origins=yes"
export CFLAGS="-O0 -g -Wl,-z,now -fPIC"
export CXXFLAGS="-O0 -g -Wl,-z,now -fPIC"
export FFLAGS="-O0 -g -Wl,-z,now -fPIC -I${MPI_FORTRAN_MOD_DIR}"
xvfb-run -a make MAKE_NP=$RPM_BUILD_NCPUS all test -C buildopenmpi_dir V=1 MPIEXEC='%{_builddir}/%{name}-%{version}/buildopenmpi_dir/lib/petsc/bin/petscmpiexec -valgrind'

pushd buildopenmpi_dir
export PETSC_ARCH=%{_arch}
export PETSC_DIR=./
MPI_PYTHON3_SITEARCH=%{python3_sitearch}/openmpi
export PYTHONPATH=%{buildroot}$MPI_PYTHON3_SITEARCH
export LD_LIBRARY_PATH=%{buildroot}$MPI_LIB
%{__python3} setup.py test
unset PETSC_ARCH
unset PETSC_DIR
popd
%{_openmpi_unload}

%{_mpich_load}
export LD_LIBRARY_PATH=%{_builddir}/%{name}-%{version}/buildmpich_dir/%{_arch}/lib
export PETSC_DIR=%{_builddir}/%{name}-%{version}/buildmpich_dir
export PETSC_ARCH=%{_arch}
export MPI_INTERFACE_HOSTNAME=localhost
export OMPI_MCA_btl_base_warn_component_unused=0
export wPETSC_DIR=./
export DATAFILESPATH=%{_builddir}/%{name}-%{version}/buildmpich_dir/share/petsc/datafiles
RPM_BUILD_NCPUS="`%{_bindir}/getconf _NPROCESSORS_ONLN`"
export PETSCVALGRIND_OPTIONS=" --tool=memcheck --leak-check=yes --track-origins=yes"
export CFLAGS="-O0 -g -Wl,-z,now -fPIC"
export CXXFLAGS="-O0 -g -Wl,-z,now -fPIC"
export FFLAGS="-O0 -g -Wl,-z,now -fPIC -I${MPI_FORTRAN_MOD_DIR}"
xvfb-run -a make MAKE_NP=$RPM_BUILD_NCPUS all test -C buildmpich_dir V=1 MPIEXEC='%{_builddir}/%{name}-%{version}/buildmpich_dir/lib/petsc/bin/petscmpiexec -valgrind'

pushd buildmpich_dir
export PETSC_ARCH=%{_arch}
export PETSC_DIR=./
MPI_PYTHON3_SITEARCH=%{python3_sitearch}/mpich
export PYTHONPATH=%{buildroot}$MPI_PYTHON3_SITEARCH
export LD_LIBRARY_PATH=%{buildroot}$MPI_LIB
%{__python3} setup.py test
unset PETSC_ARCH
unset PETSC_DIR
popd
%{_mpich_unload}

export LD_LIBRARY_PATH=%{_libdir}:%{_builddir}/%{name}-%{version}/%{name}-%{version}/%{_arch}/lib
export PETSC_DIR=%{_builddir}/%{name}-%{version}/%{name}-%{version}
export PETSC_ARCH=%{_arch}
export wPETSC_DIR=./
export DATAFILESPATH=%{_builddir}/%{name}-%{version}/%{name}-%{version}/share/petsc/datafiles
RPM_BUILD_NCPUS="`%{_bindir}/getconf _NPROCESSORS_ONLN`"
export PETSCVALGRIND_OPTIONS=" --tool=memcheck --leak-check=yes --track-origins=yes"
export CFLAGS="-O0 -g -Wl,-z,now -fPIC"
export CXXFLAGS="-O0 -g -Wl,-z,now -fPIC"
export FFLAGS="-O0 -g -Wl,-z,now -fPIC -I%{_libdir}/gfortran/modules"
xvfb-run -a make MAKE_NP=$RPM_BUILD_NCPUS all test -C %{name}-%{version} V=1 MPIEXEC='%{_builddir}/%{name}-%{version}/%{name}-%{version}/lib/petsc/bin/petscmpiexec -n $RPM_BUILD_NCPUS -valgrind'

export LD_LIBRARY_PATH=%{_libdir}:%{_builddir}/%{name}-%{version}/build64/%{_arch}/lib
export PETSC_DIR=%{_builddir}/%{name}-%{version}/build64
export PETSC_ARCH=%{_arch}
export wPETSC_DIR=./
export DATAFILESPATH=%{_builddir}/%{name}-%{version}/build64/share/petsc/datafiles
RPM_BUILD_NCPUS="`%{_bindir}/getconf _NPROCESSORS_ONLN`"
ln -s %{_builddir}/%{name}-%{version}/build64/%{_arch}/lib/libpetsc64.so %{_builddir}/%{name}-%{version}/build64/%{_arch}/lib/libpetsc.so

export PETSCVALGRIND_OPTIONS=" --tool=memcheck --leak-check=yes --track-origins=yes"
export CFLAGS="-O0 -g -Wl,-z,now -fPIC"
export CXXFLAGS="-O0 -g -Wl,-z,now -fPIC"
export FFLAGS="-O0 -g -Wl,-z,now -fPIC -I%{_libdir}/gfortran/modules"
xvfb-run -a make MAKE_NP=$RPM_BUILD_NCPUS all test -C build64 V=1 MPIEXEC='%{_builddir}/%{name}-%{version}/build64/lib/petsc/bin/petscmpiexec -n $RPM_BUILD_NCPUS -valgrind'
%endif

%files
%license %{name}-%{version}/LICENSE
%{_libdir}/libpetsc.so.3
%{_libdir}/libpetsc.so.%{releasever}
%{_libdir}/libpetsc.so.%{version}

%files devel
%{_libdir}/pkgconfig/PETSc.pc
%{_libdir}/pkgconfig/petsc.pc
%{_libdir}/%{name}/
%{_libdir}/libpetsc.so
%{_includedir}/%{name}/
%{_fmoddir}/%{name}/

%files doc
%license %{name}-%{version}/LICENSE
%{_pkgdocdir}/

%files -n petsc64
%license build64/LICENSE
%{_libdir}/libpetsc64.so.3
%{_libdir}/libpetsc64.so.%{releasever}
%{_libdir}/libpetsc64.so.%{version}

%files -n petsc64-devel
%{_libdir}/pkgconfig/PETSc64.pc
%{_libdir}/pkgconfig/petsc64.pc
%{_libdir}/%{name}64/
%{_libdir}/libpetsc64.so
%{_includedir}/%{name}64/
%{_fmoddir}/%{name}64/

%files openmpi
%license buildopenmpi_dir/LICENSE
%{_libdir}/openmpi/lib/libpetsc.so.3
%{_libdir}/openmpi/lib/libpetsc.so.%{releasever}
%{_libdir}/openmpi/lib/libpetsc.so.%{version}

%files openmpi-devel
%{_libdir}/openmpi/lib/libpetsc.so
%{_libdir}/openmpi/lib/%{name}/
%{_libdir}/openmpi/lib/pkgconfig/PETSc.pc
%{_libdir}/openmpi/lib/pkgconfig/petsc.pc
%{_includedir}/openmpi-%{_arch}/%{name}/
%{_fmoddir}/openmpi/%{name}/

%files -n python%{python3_pkgversion}-%{name}-openmpi
%{python3_sitearch}/openmpi/petsc4py/
%{python3_sitearch}/openmpi/petsc4py-%{version}-py%{python3_version}.egg-info

%files mpich
%license buildmpich_dir/LICENSE
%{_libdir}/mpich/lib/libpetsc.so.3
%{_libdir}/mpich/lib/libpetsc.so.%{releasever}
%{_libdir}/mpich/lib/libpetsc.so.%{version}

%files mpich-devel
%{_libdir}/mpich/lib/libpetsc.so
%{_libdir}/mpich/lib/%{name}/
%{_libdir}/mpich/lib/pkgconfig/PETSc.pc
%{_libdir}/mpich/lib/pkgconfig/petsc.pc
%{_includedir}/mpich-%{_arch}/%{name}/
%{_fmoddir}/mpich/%{name}/

%files -n python%{python3_pkgversion}-%{name}-mpich
%{python3_sitearch}/mpich/petsc4py/
%{python3_sitearch}/mpich/petsc4py-%{version}-py%{python3_version}.egg-info

%changelog
* Mon May 20 2024 Rebuild Robot <rebot@opencloudos.org> - 3.18.5-6
- [Type] other
- [DESC] Rebuilt for hdf5

* Tue Jan 09 2024 Rebuild Robot <rebot@opencloudos.org> - 3.18.5-5
- Rebuilt for SuperLU

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.18.5-4
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.18.5-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.18.5-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 25 2023 Shuo Wang <abushwang@tencent.com> - 3.18.5-1
- initial build
